#include "windows.h" 
#include <utility.h>
#include <cvirte.h>		
#include <userint.h>
#include "Test_CVI.h"

static int panelHandle;
static HMODULE ModuleID;

typedef int (*RTLLBYTEFUNC)(int arg1, unsigned int arg2, char *arg3);  
RTLLBYTEFUNC MMDPokeB, MMDPeekB;

int Device = 1;		//Intelligent Series Device Number
unsigned int stopByteOffset = 0;		//Byte offset of where to stop RT program
unsigned int transferByteOffset = 1;	//Byte offset of where to pause transfer
unsigned int sendByteOffset = 2;		//Byte offset of where to send data to
unsigned int recieveByteOffset = 3;		//Byte offset of where to recieve data from
char Value;			//Variable holding data being sent back and forth.




int main (int argc, char *argv[])
{
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "Test_CVI.uir", PANEL)) < 0)
		return -1;
	//Get Module ID to reference DLL
	ModuleID = LoadLibrary("C:\\PROGRA~1\\NATION~1\\LABVIEW\\resource\\elvsock.dll");
	//Get address spaces to reference functions
	MMDPokeB = (RTLLBYTEFUNC) GetProcAddress(ModuleID,"MMDPokeB");
	MMDPeekB = (RTLLBYTEFUNC) GetProcAddress(ModuleID,"MMDPeekB");
			
	DisplayPanel (panelHandle);
	RunUserInterface ();
	DiscardPanel (panelHandle);
	//Frees Module ID
	FreeLibrary(ModuleID);
	return 0;
}

int CVICALLBACK Stop (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int TransferStatus;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panelHandle, PANEL_STOP, &TransferStatus);
			if (TransferStatus)
				Value = 0;
			else
				Value = 1;
			(MMDPokeB)(Device, transferByteOffset, &Value);
			break;
		}
	return 0;
}
 
int CVICALLBACK Update (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_TIMER_TICK:
				GetCtrlVal (panelHandle, PANEL_IN_VAL, &Value);
				(MMDPokeB)(Device, sendByteOffset, &Value);
				Value = 0;
				(MMDPeekB)(Device, recieveByteOffset,&Value);
				SetCtrlVal (panelHandle, PANEL_OUT_VAL, Value);
			break;
		}
	return 0;
}

int CVICALLBACK Quit (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		//	I left this code out for debugging reasons and for others to test out
		//	the program without having to start LabVIEW every time.
		//	Value = 1;
		//	(MMDPokeB)(Device, stopByteOffset, &Value);
			
			QuitUserInterface (0);
			break;
		}
	return 0;
}

